/* RTK 2009.2.4 */

void PrejemZnaka(int x);

int znak = 0;

void PrejemPeterice(int x)
{
	/*printf("PrejemPeterice(%x)\n", x);*/
	znak <<= 4;
	znak |= x & 15;
	if (x & 16) { PrejemZnaka(znak); znak = 0; }
}

/* Preostanek tega programa ni del reitve,
   ki bi jo zahtevali od tekmovalcev, pa pa je
   namenjen testiranju. */

#include <assert.h>

int prejetiZnak = -1;

void PrejemZnaka(int x)
{
	/*printf("PrejemZnaka(%x)\n", x);*/
	assert(prejetiZnak < 0);
	assert(0 <= x && x <= (17 << 16));
	prejetiZnak = x;
}

void TestZnak(int x)
{
	int nPeteric = 1;
	/*printf("TestZnak(%x)\n", x);*/
	while ((1 << (4 * nPeteric)) <= x) nPeteric++;
	prejetiZnak = -1;
	while (nPeteric > 0) {
		nPeteric--;
		PrejemPeterice(((x >> (4 * nPeteric)) & 15) | (nPeteric == 0 ? 16 : 0)); }
	assert(prejetiZnak == x);

}

int main()
{
	int x;
	for (x = 0; x < (17 << 16); x++) TestZnak(x);
	for (x = 0; x < 1 << 24; x++) TestZnak(rand() % (17 << 16));
	return 0;
}
